"""
Django settings for scoreboard project.

Generated by 'django-admin startproject' using Django 3.0.3.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""


from pathlib import Path
import env
import sys
from django.urls import reverse_lazy
from django.utils import timezone

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = Path(__file__).resolve(strict=True).parent.parent
APPS_DIR = BASE_DIR / "apps"
sys.path.append(str(APPS_DIR))

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = env.get_secret("DJANGO_SECRET_KEY")

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = env.get_bool("DJANGO_DEBUG", False)

ALLOWED_HOSTS = env.get_list("DJANGO_ALLOWED_HOSTS", [])
DEFAULT_DOMAIN = ALLOWED_HOSTS[0] if ALLOWED_HOSTS else "localhost"

# A list of all the people who get code error notifications.
ADMINS = [(mail, mail) for mail in env.get_list("DJANGO_ADMINS", [])]

# Redirect plain HTTP requests to HTTPS.
SECURE_SSL_REDIRECT = not DEBUG

# Set this to True to avoid transmitting the CSRF cookie over HTTP accidentally.
CSRF_COOKIE_SECURE = not DEBUG

# Set this to True to avoid transmitting the session cookie over HTTP accidentally.
SESSION_COOKIE_SECURE = not DEBUG

# See https://docs.djangoproject.com/en/3.0/ref/middleware/#referrer-policy
SECURE_REFERRER_POLICY = "strict-origin-when-cross-origin"

SECURE_PROXY_SSL_HEADER = ("HTTP_X_FORWARDED_PROTO", "https")
# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django.contrib.postgres",
    "social_django",
    "common",
    "bulk_user_add",
    "landing_page",
    "vote",
]

MIDDLEWARE = [
    "conf.middleware.ProbesMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
    "social_django.middleware.SocialAuthExceptionMiddleware",
]

ROOT_URLCONF = "urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [APPS_DIR / "templates"],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "social_django.context_processors.backends",
                "social_django.context_processors.login_redirect",
            ],
        },
    },
]

WSGI_APPLICATION = "wsgi.application"

LOG_LEVEL = env.get_string("DJANGO_LOG_LEVEL", "DEBUG" if DEBUG else "WARNING").upper()

# A data structure containing configuration information. The contents of this
# data structure will be passed as the argument to the configuration method
# described in LOGGING_CONFIG.

LOGGING = {
    "version": 1,
    "disable_existing_loggers": False,
    "formatters": {
        "django.server": {
            "()": "django.utils.log.ServerFormatter",
            "format": "[{server_time}] {message}",
            "style": "{",
        },
        "default": {
            "()": "logging.Formatter",
            "format": "[{levelname}:{name}] {message}",
            "style": "{",
        },
    },
    "filters": {"require_debug_false": {"()": "django.utils.log.RequireDebugFalse"}},
    "handlers": {
        "console": {
            "level": "DEBUG",
            "class": "logging.StreamHandler",
            "formatter": "default",
        },
        "django.server": {
            "level": "DEBUG",
            "class": "logging.StreamHandler",
            "formatter": "django.server",
        },
        "mail_admins": {
            "level": "ERROR",
            "filters": ["require_debug_false"],
            "class": "django.utils.log.AdminEmailHandler",
        },
    },
    "loggers": {
        "django": {
            "handlers": ["console", "mail_admins"],
            "level": LOG_LEVEL,
            "propagate": False,
        },
        "django.server": {
            "handlers": ["django.server"],
            "level": "INFO",
            "propagate": False,
        },
    },
    "root": {"handlers": ["console"], "level": LOG_LEVEL},
}


# Database

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.postgresql",
        "NAME": env.get_string("DJANGO_DB_NAME", "scoreboard_seedbox_cri"),
        "USER": env.get_string("DJANGO_DB_USER", "scoreboard_seedbox_cri"),
        "PASSWORD": env.get_secret("DJANGO_DB_PASSWORD"),
        "HOST": env.get_string("DJANGO_DB_HOST"),
        "PORT": env.get_string("DJANGO_DB_PORT", "5432"),
    },
}


# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",  # noqa: E501
    },
    {"NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",},
    {"NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",},
    {"NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",},
]


# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "Europe/Paris"

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATICFILES_DIRS = [
    APPS_DIR / "static",
]

AWS_ACCESS_KEY_ID = env.get_secret("S3_ACCESS_KEY")
AWS_SECRET_ACCESS_KEY = env.get_secret("S3_SECRET_KEY")
AWS_STORAGE_BUCKET_NAME = env.get_string("S3_BUCKET", "catcdc")
AWS_S3_ENDPOINT_URL = env.get_string("S3_ENDPOINT")
AWS_S3_CUSTOM_DOMAIN = env.get_string("S3_CUSTOM_DOMAIN", "") or None
AWS_S3_SECURE_URLS = env.get_bool("S3_SECURE_URLS", True)

AWS_BUCKET_ACL = "public-read"
AWS_DEFAULT_ACL = "public-read"
AWS_QUERYSTRING_AUTH = True
AWS_S3_OBJECT_PARAMETERS = {"ACL": "public-read"}

STATIC_URL = "/catcdc/static/"
STATICFILES_STORAGE = "conf.storage_backends.StaticStorage"
MEDIA_URL = "/catcdc/media/"
DEFAULT_FILE_STORAGE = "conf.storage_backends.PublicMediaStorage"


# Auth

LOGIN_REDIRECT_URL = reverse_lazy("landing_page")
LOGOUT_REDIRECT_URL = reverse_lazy("landing_page")
LOGIN_ERROR_URL = reverse_lazy("landing_page")

AUTHENTICATION_BACKENDS = (
    "social_auth_backend_epita.backend.EpitaOpenIdConnect",
    "django.contrib.auth.backends.ModelBackend",
)


# Social auth

SOCIAL_AUTH_EPITA_KEY = env.get_secret("DJANGO_SOCIAL_AUTH_EPITA_KEY")
SOCIAL_AUTH_EPITA_SECRET = env.get_secret("DJANGO_SOCIAL_AUTH_EPITA_SECRET")

SOCIAL_AUTH_EPITA_SCOPE = [
    "profile",
    "epita",
]

SOCIAL_AUTH_PIPELINE = (
    # Get the information we can about the user and return it in a simple
    # format to create the user instance later. In some cases the details are
    # already part of the auth response from the provider, but sometimes this
    # could hit a provider API.
    "social_core.pipeline.social_auth.social_details",
    # Get the social uid from whichever service we're authing thru. The uid is
    # the unique identifier of the given user in the provider.
    "social_core.pipeline.social_auth.social_uid",
    # Verifies that the current auth process is valid within the current
    # project, this is where emails and domains whitelists are applied (if
    # defined).
    "social_core.pipeline.social_auth.auth_allowed",
    # Prevents users with an updated username to sign in with their old
    # identity.
    "social_auth_backend_epita.pipeline.deny_old_users",
    # Checks if the current social-account is already associated in the site.
    "social_core.pipeline.social_auth.social_user",
    # Make up a username for this person, appends a random string at the end if
    # there's any collision.
    "social_core.pipeline.user.get_username",
    # Merge old accounts into the new one when a username update is detected
    "social_auth_backend_epita.pipeline.merge_old_users",
    # Send a validation email to the user to verify its email address.
    # Disabled by default.
    # 'social_core.pipeline.mail.mail_validation',
    # Associates the current social details with another user account with
    # a similar email address. Disabled by default.
    #'social_core.pipeline.social_auth.associate_by_email',
    # Create a user account if we haven't found one yet.
    # "social_core.pipeline.user.create_user",
    # Create the record that associates the social account with the user.
    "social_core.pipeline.social_auth.associate_user",
    # Populate the extra_data field in the social record with the values
    # specified by settings (and the default ones like access_token, etc).
    "social_core.pipeline.social_auth.load_extra_data",
    # Update the user record with any changed info from the auth service.
    "social_core.pipeline.user.user_details",
    # Update email if necessary since the above function ignores email updates.
    "social_auth_backend_epita.pipeline.update_email",
)

SUBMISSION_START = timezone.get_current_timezone().localize(
    timezone.datetime(2020, 3, 30, 11, 42, 0)
)
SUBMISSION_END = timezone.get_current_timezone().localize(
    timezone.datetime(2020, 4, 5, 23, 42, 0)
)
VOTE_START = timezone.get_current_timezone().localize(
    timezone.datetime(2020, 4, 6, 11, 42, 0)
)
VOTE_END = timezone.get_current_timezone().localize(
    timezone.datetime(2020, 4, 12, 23, 42, 0)
)
